## mingw-w64-siesta-5.0.0-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20 FATAL_ERROR)

# CMAKE_MODULE_PATH is locally searched for *.cmake files
# before CMAKE_PREFIX_PATH.
# We will prefer to use CMAKE_MODULE_PATH
list(APPEND
  CMAKE_MODULE_PATH
  # add the generic configuration cmake directory
  "${CMAKE_CURRENT_SOURCE_DIR}/Config/cmake"
  # add the external modules directory
  "${CMAKE_CURRENT_SOURCE_DIR}/Config/cmake/Modules"
  )

# Define project details
# Add [siesta] to the output
list(APPEND CMAKE_MESSAGE_CONTEXT siesta)
project(
  SIESTA
  LANGUAGES Fortran C
  HOMEPAGE_URL "https://siesta-project.org/siesta"
  DESCRIPTION "A first-principles materials simulation code using DFT."
  )

set(SIESTA_AUTHOR  "Siesta group")
set(SIESTA_LICENSE "GPLv3")
#-----

# Follow GNU conventions for installing directories
# This will use the bin/ include/ etc. folder structure
include(GNUInstallDirs)

# Include Siesta specific utility functions
include(SiestaUtils)
siesta_util_ensure_out_of_source_build()

if(PROJECT_IS_TOP_LEVEL)
  if(SIESTA_ALLOW_LEGACY_OPTION_NAMES) # Please try to avoid this
    include(SiestaEnableLegacyOptions)
  else()
    include(SiestaBlockLegacyOptions)
  endif()
else()
  message(STATUS "*** Siesta is being configured as a subproject***")
  message(STATUS "CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}")
  message(STATUS "PROJECT_SOURCE_DIR: ${PROJECT_SOURCE_DIR}")
  include(SiestaBlockLegacyOptions)
endif()
#
# Compiler flags
include(SiestaFlags)

# -- Options ----------------------------------------

# This is just to have the user choose how to do the build
# generally they don't need to be touched, but it can be useful
# when siesta is used as a submodule.
option(SIESTA_TESTS "Siesta: Build test-suite" ${PROJECT_IS_TOP_LEVEL})
option(SIESTA_SHARED_LIBS "Siesta: Build as a shared library" ${PROJECT_IS_TOP_LEVEL})
option(SIESTA_INSTALL "Siesta: Install project" ${PROJECT_IS_TOP_LEVEL})
# this should be advanced, as it is primarily useful for users of Siesta as a
# sub-project.
mark_as_advanced(SIESTA_INSTALL SIESTA_TESTS SIESTA_SHARED_LIBS)

option(SIESTA_WITH_GRID_SP "Siesta: Use single-precision for grid magnitudes" FALSE)

option(SIESTA_BUILD_DOCS "Siesta: Create Doxygen-based documentation (WIP)" FALSE)
option(SIESTA_WITH_PEXSI "Siesta: Use the PEXSI library (direct interface)" FALSE)
option(SIESTA_WITH_WANNIER90 "Siesta: Use the wannier90 interface" FALSE)
option(SIESTA_WITH_CHESS "Siesta: Use the CheSS linear-scaling library from BigDFT" FALSE)

# If SIESTA_WITH_UNIT_CONVENTION is set as a normal variable by a
# super-project, the normal variable will take precedence in
# principle, but versions of CMake older than 3.21 will *remove* the
# normal variable when executing the set(...CACHE...) statement...  So
# this must be wrapped

if(PROJECT_IS_TOP_LEVEL)
 # Command-line options take precedence over this, since the 'force' option is not
 # given, for obvious reasons
 set(SIESTA_WITH_UNIT_CONVENTION "CODATA2018"
   CACHE STRING
   "Decide which units ${PROJECT_NAME} should be compiled with [original,legacy,codata2018]"
   )
 # Define the available options for cmake-gui
 set_property(CACHE SIESTA_WITH_UNIT_CONVENTION
   PROPERTY STRINGS
   "original" "legacy" "CODATA2018"
 )
# Do not make this public
 mark_as_advanced(SIESTA_WITH_UNIT_CONVENTION)

else()
 if (NOT DEFINED SIESTA_WITH_UNIT_CONVENTION)
  set(SIESTA_WITH_UNIT_CONVENTION "CODATA2018")
 endif()
endif()

# ------------------------------------------------


# Use Pkg-Config if available
# Many of our sub-inclusions requires this one, so we will catch errors here
# To not confuse users!
find_package(PkgConfig REQUIRED)


# -- Version information
message(CHECK_START "Checking Siesta version")
list(APPEND CMAKE_MESSAGE_INDENT "  ")

# Before searching for any versions, we create the required version files
# that can be used to track version information
execute_process(COMMAND sh "${PROJECT_SOURCE_DIR}/Tools/version_generate.sh"
  WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
  OUTPUT_VARIABLE SIESTA_VERSION
  RESULT_VARIABLE VERSION_RESULT
  ERROR_VARIABLE VERSION_STDERR)

# fix omission from vgen which sometimes has a newline
string(REGEX REPLACE "\n" " " SIESTA_VERSION "${SIESTA_VERSION}")
string(STRIP "${SIESTA_VERSION}" SIESTA_VERSION)
message(STATUS "SIESTA_VERSION: ${SIESTA_VERSION} (err=${VERSION_RESULT})")
# Pretty print the error content
if(VERSION_RESULT EQUAL 2)
  set(tmp CHECK_FAIL)
  set(tmp_msg "not found")
elseif(VERSION_RESULT EQUAL 3)
  set(tmp CHECK_PASS)
  set(tmp_msg "found development version")
else()
  set(tmp CHECK_PASS)
  set(tmp_msg "found release version")
endif()

message(STATUS "${VERSION_STDERR}")
list(POP_BACK CMAKE_MESSAGE_INDENT)
message(${tmp} "${tmp_msg}")


# Look for blas, if needed, it is not required if LAPACK ships BLAS
find_package(CustomBlas)

# Look for LAPACK
find_package(CustomLapack REQUIRED)

if(NOT TARGET MPI::MPI_Fortran)
 # Find MPI
 find_package(MPI OPTIONAL_COMPONENTS Fortran C)
endif()

# AG: Scalapack-related logic should perhaps be updated

if(MPI_Fortran_FOUND)
  find_package(CustomScalapack)
  if( NOT SCALAPACK_FOUND )
    message(WARNING
      "MPI is found, but ScaLAPACK library cannot be found (or compiled against).\n"
      "If parallel support is required please supply the ScaLAPACK library with appropriate "
      "flags:\n"
      " -DSCALAPACK_LIBRARY=<lib>")
    set(MPI_Fortran_FOUND FALSE)
  endif()
endif()

option(SIESTA_WITH_MPI "Build Siesta with MPI support" ${MPI_Fortran_FOUND})
if( SIESTA_WITH_MPI )

  if(NOT MPI_Fortran_FOUND)
    message(WARNING
      "MPI could not be found by CMake"
      "Try setting MPI_Fortran_COMPILER to an MPI wrapper, or the MPI_HOME env variable"
      "If unsuccessful, set -DSIESTA_WITH_MPI=OFF")
    message(FATAL_ERROR "MPI was requested, but could not be found by CMake")
  endif()
  if( NOT SCALAPACK_FOUND )
    message(WARNING
      "ScaLAPACK could not be found by CMake"
      "Try adding SCALAPACK_LIBRARIES with appropriate flags"
      "If ScaLAPACK is not present MPI needs to be turned off:\n"
      "  -DSIESTA_WITH_MPI=OFF"
      )
    message(FATAL_ERROR "MPI was requested, but ScaLAPACK could not be found by CMake")
  endif()

endif()

# Now we can check for linear algebra stuff
include(SiestaCheckLinalg)
include(SiestaCheckLinalgFeatures)

#---------------------------- OpenMP
# OpenMP *must* be user-requested since it brings additional
# overhead. We should also, for consistency check whether the LAPACK
# and/or BLAS libraries support OpenMP in some form.
# There is little gain when using OpenMP and BLAS libraries are not threaded.
option(SIESTA_WITH_OPENMP "Build with OpenMP support (very few utilities will benefit)" FALSE)
if( SIESTA_WITH_OPENMP )

  if(NOT TARGET OpenMP::OpenMP_Fortran)
    find_package(OpenMP COMPONENTS Fortran C)

    if( OpenMP_FOUND )

      if(NOT OpenMP_Fortran_HAVE_OMPLIB_MODULE)
        message(ERROR_FATAL "OpenMP does not have the 'omp_lib' module used by Siesta OpenMP")
      endif()
      
    else()
      message(ERROR_FATAL "OpenMP support requested but could not find any OpenMP flags")
    endif()
  endif()
  
endif()

# NETCDF -- First, a fault check for case-sensitive arguments
# Instead of relying on multiple variants, we should just
# kill the build.
# The problem is that NetCDF *may* require additional
# variables in correct case format. And if we allow upper-case
# for the _ROOT variable, we should do so for all of the variables
# which turns out to be a mess... (we can do a loop if we have everything,
# but for now lets not do this.
foreach(name IN ITEMS "PATH" "ROOT")
  if( (DEFINED NETCDF_${name}) AND (NOT DEFINED NetCDF_${name}) )
    message(WARNING
      "Searching for NetCDF requires the correct case of the search."
      "The build script detected that NETCDF_${name} is defined whereas "
      "NetCDF_${name} is not defined.\n"
      "The search for the NetCDF library requires that you use the "
      "NetCDF_* format for variables. E.g. do this:\n"
      " -DNetCDF_${name}=${NETCDF_${name}}\n"
      "on the command-line instead.")
    message(FATAL_ERROR "Wrong case-notation of NetCDF search variables.")
  endif()
endforeach()

find_package(NetCDF 4.0.0 COMPONENTS Fortran C)

message(DEBUG "NetCDF_Fortran_INCLUDE_DIRS: ${NetCDF_Fortran_INCLUDE_DIRS}")
message(DEBUG "NetCDF_C_INCLUDE_DIRS: ${NetCDF_C_INCLUDE_DIRS}")

if (DEFINED SIESTA_WITH_NetCDF AND (NOT DEFINED SIESTA_WITH_NETCDF))
  message(FATAL_ERROR "Please use SIESTA_WITH_NETCDF and not SIESTA_WITH_NetCDF as the option name")
endif()

option(SIESTA_WITH_NETCDF "Build Siesta with NetCDF support" ${NetCDF_Fortran_FOUND})

if (SIESTA_WITH_NETCDF AND (NOT NetCDF_Fortran_FOUND))
  message(WARNING
    "NetCDF_Fortran is requested but could not be found by CMake.\n"
    "Try setting variables these variables for searching:\n"
    " - NetCDF_ROOT or NetCDF_PATH\n"
    " - NetCDF_INCLUDE_DIR or NetCDF_Fortran_INCLUDE_DIR\n"
    " - NetCDF_INCLUDE_DIRS or NetCDF_Fortran_INCLUDE_DIRS\n"
    "to appropriate variables for discovering NetCDF fortran libraries."
    "Another possibility would be to add the NetCDF cmake package path to\n"
    "  CMAKE_PREFIX_PATH\n"
    "for automatic discovery."
    "If still unsuccessful, please disable NetCDF support with:\n"
    "  -DSIESTA_WITH_NETCDF=OFF\n")
  message(FATAL_ERROR "NetCDF could not be found by CMake")
endif()

option(SIESTA_WITH_NCDF "Use the NCDF library" ${SIESTA_WITH_NETCDF})


if( SIESTA_WITH_NETCDF )

  if (SIESTA_WITH_MPI)
    # Note that MPI must be enabled for this to make sense
    option(SIESTA_WITH_NCDF_PARALLEL "Use NCDF_PARALLEL" ${NetCDF_PARALLEL})
  else()
    option(SIESTA_WITH_NCDF_PARALLEL "Use NCDF_PARALLEL" FALSE)
  endif()

else()

  # We "shadow" any cache values of SIESTA_WITH_NCDF and
  # SIESTA_WITH_NCDF_PARALLEL with the values of normal variables.
  # Avoid modifying any cache values, which might not have the desired
  # effect in all versions of CMake (see policy 0126)

  set(SIESTA_WITH_NCDF FALSE)
  set(SIESTA_WITH_NCDF_PARALLEL FALSE)

endif()


# Handle external dependencies
# Use proper order for xmlf90 and libpsml dependencies
if (NOT TARGET libfdf::libfdf)
  find_package(Customlibfdf REQUIRED)
endif()

if (NOT TARGET xmlf90::xmlf90)
  find_package(Customxmlf90 REQUIRED)
endif()

if (NOT TARGET libpsml::libpsml)
  find_package(Customlibpsml REQUIRED)
endif()
# ensure libpsml links with xmlf90
target_link_libraries(libpsml::libpsml
  INTERFACE
  xmlf90::xmlf90)

if(NOT LIBPSML_USES_PROCEDURE_POINTER )

  siesta_suffix_install()

  # Work around bug in shared library linking
  # This should only temporarily be a hack since future
  # psml versions will always rely on procedure pointers
  add_library(${PROJECT_NAME}-psml_wrappers
    STATIC
    "${CMAKE_CURRENT_SOURCE_DIR}/Src/psml_wrappers.F90"
  )

  siesta_suffix_uninstall()

  # One cannot use OBJECT libraries as their objects are not
  # passed down to subsequent dependent usages. I.e. that would cause
  # name-collisions for static libraries.
  target_link_libraries(libpsml::libpsml
    INTERFACE
    ${PROJECT_NAME}-psml_wrappers
  )

endif()

if (NOT TARGET Libxc::xc_Fortran)
  find_package(CustomLibxc)
  if (TARGET Libxc::xc_Fortran)
    message(VERBOSE "Defining new target libxc::XC_Fortran...")
    add_library(libxc::XC_Fortran INTERFACE IMPORTED)
    target_link_libraries(libxc::XC_Fortran
      INTERFACE
      Libxc::xc_Fortran)
  endif()
endif()

option(SIESTA_WITH_LIBXC "Include libxc support" ${LIBXC_Fortran_FOUND})

if( SIESTA_WITH_LIBXC AND (NOT LIBXC_Fortran_FOUND) )
  message(WARNING
    "Libxc support has been requested ${SIESTA_WITH_LIBXC} : ${LIBXC_Fortran_FOUND}, but the fortran libxc library cannot be found.")
  message(FATAL_ERROR "Libxc could not be found by CMake")
endif()

if (NOT TARGET libgridxc::libgridxc)
  find_package(CustomLibGridxc REQUIRED)
endif()
if(NOT LIBGRIDXC_USES_PROCEDURE_POINTER)

  siesta_suffix_install()

  add_library(${PROJECT_NAME}-gridxc_wrappers

=== Src/CMakeLists.txt ===
set(libsiesta_sources

  Fstack.T90
  Pair.T90
  alloc.F90
  alloc_handlers_m.F90
  amn.F90
  arw.f
  atm_types.f
  atmfuncs.f
  atmparams.f
  atom.F
  atom_graph.F90
  atom_options.F90
  atomlist.f
  atomlwf.F
  automatic_cell.f
  bands.F
  basic_func.inc
  basic_type.inc
  basis_enthalpy.f90
  basis_io.F
  basis_specs.f
  basis_types.f
  bessph.f
  bloch_unfold.F90
  bonds.f
  born_charge.F
  broadcast_basis.F
  broadcast_fdf_struct.F90
  broadcast_projections.F
  broyden_optim.F
  bsc_cellxc.F
  byte_count.F90
  cart2frac.f
  cell_broyden_optim.F
  cell_fire_optim.F
  cellsubs.f
  cgvc.F
  cgvc_zmatrix.F
  cgwf.F
  chemical.f
  chempot.F
  chkdim.f
  chkgmx.f
  class_Data1D.F90
  class_Data1D.T90
  class_Data2D.F90
  class_Data2D.T90
  class_Data3D.F90
  class_Data3D.T90
  class_Distribution.F90
  class_Fstack_Data1D.F90
  class_Fstack_Pair_Data1D.F90
  class_Fstack_Pair_Geometry_SpData2D.F90
  class_Fstack_Pair_SpData1D.F90
  class_Geometry.F90
  class_OrbitalDistribution.F90
  class_Pair_Data1D.F90
  class_Pair_Geometry_SpData2D.F90
  class_Pair_SpData1D.F90
  class_SpData1D.F90
  class_SpData1D.T90
  class_SpData2D.F90
  class_SpData2D.T90
  class_SpData3D.F90
  class_SpData3D.T90
  class_Sparsity.F90
  class_TriMat.F90
  class_TriMat.T90
  cli_m.f90
  coceri.f
  compute_dm.F
  compute_ebs_shift.F90
  compute_energies.F90
  compute_max_diff.F90
  compute_norm.F
  compute_pw_matrix.F90
  ${PROJECT_BINARY_DIR}/Src/configured_values_m.F90
  conjgr.f
  conjgr_old.f
  constr.f
  coor.F
  coxmol.f
  cranknic_evolg.F90
  cranknic_evolk.F90
  create_Sparsity_SC.F90
  create_Sparsity_Union.F90
  cross.f
  debugmpi.F
  delk.F90
  denmat.F
  denmatlomem.F
  densematrix.f90
  detover.F
  dfscf.f
  dftu.F
  dftu_specs.f
  dhscf.F
  diag.F90
  diag2g.F
  diag2k.F
  diag2kp.F90
  diag2kspiral.F90
  diag3g.F
  diag3k.F
  diag3kp.F90
  diag_option.F90
  diagg.F
  diagk.F
  diagk_file.F
  diagkp.F
  diagkp_velocity.F90
  diag2kp_velocity.F90
  diag3kp_velocity.F90
  diagmemory.F
  diagon.F
  diagonalizeHk.F90
  diagpol.f
  digcel.f
  dipole.F90
  dismin.f
  dm_charge.F90
  dnaefs.f
  domain_decom.F
  doping_uniform.F
  dot.f
  dynamics.F
  egandd.F
  eggbox.F
  electrostatic.f
  ener3.F
  ener3lomem.F
  errorf.f
  extrae_eventllist.F90
  extrae_module.f90
  extrapolateSpData2D.F90
  extrapolon.f
  fdf_extra.F90
  fermid.F
  fft.F
  fft1d.F
  files.f
  final_H_f_stress.F
  find_kgrid.F
  fire_optim.F
  flook_siesta.F90
  forhar.F
  fsiesta_mpi.F90
  fsockets.f90
  geom_helper.f90
  get_kpoints_scale.f90
  get_target_stress.f
  globalise.F
  gradient.F
  gradientlomem.F
  grimme_dispersion_m.F90
  grdsam.F
  hamann.f90
  hsparse.F
  idiag.f
  init_output.f90
  initatom.f
  initparallel.F
  interpolation.f90
  intrinsic_missing.F90
  inver.f
  io.f
  io_sparse.F90
  iocg.f
  iodm.F
  iodm_netcdf.F90
  iodmhs_netcdf.F90
  ioeig.f
  iofa.f90
  iogrid_netcdf.F90
  iokp.f
  iolwf.F
  iomd.f
  iopipes.F90
  iosockets.F90
  iotdxv.F
  iowfs_netcdf.F90
  ioxv.F
  iozm.F
  ipack.f
  kgrid.F
  kgridinit.F
  kinefsm.f
  kpoint_convert.f90
  kpoint_dos.F90
  kpoint_ldos.F90
  kpoint_pdos.F90
  kpoint_scf.F90
  kpoint_t.F90
  ksv.f
  ksvinit.F
  linpack.F
  listsc.f
  local_DOS.F90
  m_broyddj.f90
  m_broyddj_nocomm.f90
  m_broyden_mixing.f
  m_cell.f
  m_char.f90
  m_charge_add.F90
  m_check_walltime.f90
  m_chempotwann.F90 
  m_chess.F90
  m_cite.F90
  m_convergence.f90
  m_dftu_so.F90
  m_digest_nnkp.F90
  m_diis.F90
  m_dipol.F90
  m_dminim.F90
  m_dscfcomm.F
  m_efield.F90
  m_energies.F90
  m_eo.F90
  m_evolve.F90
  m_exp_coord.F90
  m_fft_gpfa.F
  m_filter.f90
  m_fire.f90
  m_fire_mixing.f
  m_fire_para.F90
  m_fixed.F90
  m_forces.F90
  m_gauss_fermi_17.f90
  m_gauss_fermi_18.f90
  m_gauss_fermi_19.f90
  m_gauss_fermi_20.f90
  m_gauss_fermi_22.f90
  m_gauss_fermi_24.f90
  m_gauss_fermi_26.f90
  m_gauss_fermi_28.f90
  m_gauss_fermi_30.f90
  m_gauss_fermi_inf.f90
  m_gauss_quad.f90
  m_geom_aux.f90
  m_geom_box.f90
  m_geom_coord.f90
  m_geom_objects.f90
  m_geom_plane.f90
  m_geom_square.f90
  m_getopts.f90
  m_handle_sparse.F90
  m_hartree_add.F90
  m_hs_matrix.f90
  io_hsx.F90
  m_initwf.F90
  m_integrate.f90
  m_interpolate.F90
  m_inversemm.F90
  m_io.f
  m_io_yaml.F90
  m_iodipol.F90
  m_iodm.F90
  m_iodm_old.F
  m_iorho.F
  m_iostruct.f
  m_iotddft.F90
  m_iterator.f90
  m_kinetic.F90
  m_mat_invert.F90
  m_matdiag.F90
  m_matio.F90
  m_matswinvers.F90
  m_mesh_node.F90
  m_mixing.F90
  m_mixing_scf.F90
  m_monitor.F90
  m_mpi_utils.F
  m_ncdf_siesta.F90
  m_new_dm.F90
  m_noccbands.f
  m_ntm.F90
  m_occ_proj_dftu.F90
  m_options.f90
  m_orderbands.F
  m_os.F90
  m_overkkneig.F90
  m_partial_charges.F90
  m_pivot.F90
  m_pivot_array.f90
  m_pivot_methods.F90
  m_planewavematrix.F90
  m_planewavematrixvar.F90
  m_pot_dftu.F90
  m_region.F90
  m_rhog.F90
  m_rmaxh.F90
  m_sparse.F90
  m_sparsity_handling.F90
  m_spin.F90
  m_steps.F90
  m_stress.F90
  m_supercell.F90
  m_svd.F90
  m_switch_local_proj.F90 
  m_target_stress.F90
  m_test_io.F90
  m_timer.F90
  m_transiesta.F90
  m_trialorbitalclass.f90
  m_trimat_invert.F90
  m_ts_aux.F90
  m_ts_cctype.f90
  m_ts_chem_pot.F90
  m_ts_contour.f90
  m_ts_contour_eq.f90
  m_ts_contour_neq.f90
  m_ts_debug.F90
  m_ts_dm_update.F90
  m_ts_elec_se.F90
  m_ts_electrode.F90
  m_ts_full_scat.F90
  m_ts_fullg.F90
  m_ts_fullk.F90
  m_ts_gf.F90
  m_ts_global_vars.f90
  m_ts_hartree.F90
  m_ts_io.F90
  m_ts_io_contour.f90
  m_ts_io_ctype.f90
  m_ts_iodm.F90
  m_ts_method.f90
  m_ts_mumps_init.F90
  m_ts_mumps_scat.F90
  m_ts_mumpsg.F90
  m_ts_mumpsk.F90
  m_ts_options.F90
  m_ts_pivot.F90
  m_ts_rgn2trimat.F90
  m_ts_sparse.F90
  m_ts_sparse_helper.F90
  m_ts_tdir.f90
  m_ts_tri_common.F90
  m_ts_tri_init.F90
  m_ts_tri_scat.F90
  m_ts_trig.F90
  m_ts_trik.F90
  m_ts_trimat_invert.F90
  m_ts_voltage.F90
  m_ts_weight.F90
  m_uuid.f90
  m_vee_integrals.F90
  m_wallclock.f90
  m_walltime.f90
  m_wannier_in_nao.F90
  m_w90_wrapper.F90
  m_writedelk.F
  m_zminim.F90
  madelung.f
  matel_registry.F90
  md_out.F90
  memory.F
  memory_all.F90
  memory_log.F90
  memory_snapshot.f90
  mesh.F
  meshcomm.F
  meshdscf.F
  meshphi.F
  meshsubs.F
  metaforce.F
  minvec.f
  mixer.F
  mmio.F
  mmn.F90
  mneighb.f
  molecularmechanics.F90
  moments.F
  moreParallelSubs.F90
  moremeshsubs.F
  mulliken.F
  naefs.f
  nag.f
  ncdf_io.F90
  new_matel.f
  nlefsm.f
  normalize_dm.F90
  obc.f
  object_debug.F90
  ofc.f90
  on_subs.F
  onmod.F
  optical.F
  ordern.F
  outcell.f
  outcoor.f
  overfsm.f90
  overlap.f
  parallel.F
  parallelsubs.F
  parsing.f
  pdos.F90
  pdos2g.F90
  pdos2k.F90
  pdos2kp.F90
  pdos3g.F90
  pdos3k.F90
  pdos3kp.F90
  pdosg.F90
  pdosk.F90
  pdoskp.F90
  periodic_table.f
  phirphi.f
  phirphi_opt.f
  pixmol.f
  plcharge.F
  poison.F
  posix_calls.f90
  post_scf_work.F
  precision.F
  print_spin.F90
  printmatrix.F
  projected_DOS.F90
  propor.f
  proximity_check.F
  pspltm1.F
  pxf.F90
  qsort.F
  radfft.f
  radial.f
  randomg.f90
  read_options.F90
  read_xc_info.F
  reclat.f
  redcel.F
  register_rfs.F90
  reinit_m.F90
  remove_intramol_pressure.f90
  reoptical.F
  reord.f
  reordpsi.F
  restructSpData2D.F90
  rhofft.F
  rhooda.F
  rhoofd.F90
  rhoofdsp.F90
  runinfo_m.F90
  rusage.f90
  sankey_change_basis.F90
  save_density_matrix.F90
  savepsi.F
  scfconvergence_test.F
  schecomm.F
  setatomnodes.F
  setspatial.f
  setup_H0.F
  setup_hamiltonian.F
  setup_ordern_indexes.F90
  shaper.f
  show_distribution.f
  siesta2wannier90.F90
  siesta_analysis.F
  siesta_cml.f90
  siesta_cmlsubs.F90
  siesta_dicts.F90
  siesta_end.F
  siesta_forces.F90
  siesta_geom.F90
  siesta_handlers_m.F90
  siesta_init.F
  siesta_master.f90
  siesta_move.F
  siesta_options.F90
  siesta_tddft.F90
  siesta_version_info.F90
  sockets.c
  sorting.f
  sparse_matrices.F90
  spatial.F
  spher_harm.f
  spin_subs.F90
  spinorbit.f
  state_analysis.F
  state_init.F
  struct_init.F
  timer.F90
  timer_tree.f90
  timestamp.f90
  transition_rate.F
  ts_charge.F90
  ts_dq.F90
  ts_energies.F90
  ts_electrode.F90
  ts_init.F90
  ts_kpoint_scf.F90
  ts_show_regions.f90
  typecell.f
  uncell.f
  vacuum_level.f90
  velocity_shift.F90
  vmat.F90
  vmatsp.F90
  vmb.F
  volcel.f
  wannier90_types.f
  w90_wrapper_types.f 
  wavefunctions.F90
  write_inp_wannier.F90
  write_md_record.F
  write_orb_indx.f90
  write_raw_efs.f90
  write_subs.F
  writewave.F
  xml.f
  zm_broyden_optim.F
  zm_fire_optim.F
  zmatrix.F
)

if( SIESTA_WITH_PROFILE_NVTX )
  list(APPEND libsiesta_sources nvtx-profiling/nvtx_wrapper.F90)
  set_source_files_properties(
             timer.F90
	     nvtx-profiling/nvtx_wrapper.F90
             PROPERTIES  COMPILE_DEFINITIONS "__PROFILE_NVTX")
  if ("${SIESTA_PROFILE_NVTX_LIBRARY}" STREQUAL "")
     message(WARNING "SIESTA_PROFILE_NVTX_LIBRARY is not defined. Will not profile")
     list(APPEND libsiesta_sources nvtx-profiling/dummy_nvtx.c)
  endif()
  
endif()	 

if( SIESTA_WITH_PEXSI )
  list(APPEND libsiesta_sources

    pexsi-solver/m_pexsi.F90
    pexsi-solver/m_pexsi_dos.F90
    pexsi-solver/m_pexsi_driver.F90
    pexsi-solver/m_pexsi_local_dos.F90
    pexsi-solver/m_redist_spmatrix.F90
    pexsi-solver/siesta_pexsi_interface.F90
 )
endif()

# Create libsiesta target.
siesta_add_library(SIESTA_libsiesta
    ${libsiesta_sources}
  CUSTOM_TARGET libsiesta
  NAMESPACE_TARGET libsiesta)
set_target_properties(SIESTA_libsiesta
  PROPERTIES
  EXPORT_NAME siesta
  OUTPUT_NAME siesta
)

target_compile_definitions(SIESTA_libsiesta
  PUBLIC
  $<$<BOOL:${SIESTA_WITH_MPI}>:MPI>
  $<$<BOOL:${SIESTA_WITH_GRID_SP}>:GRID_SP>
  $<$<BOOL:${SIESTA_WITH_ELPA}>:SIESTA__ELPA>
  $<$<BOOL:${SIESTA_WITH_PEXSI}>:SIESTA__PEXSI>
  $<$<BOOL:${SIESTA_WITH_CHESS}>:SIESTA__CHESS>
  $<$<BOOL:${SIESTA_WITH_NETCDF}>:CDF>
  $<$<BOOL:${SIESTA_WITH_NCDF}>:NCDF NCDF_4>
  $<$<BOOL:${SIESTA_WITH_NCDF_PARALLEL}>:NCDF_PARALLEL>
  $<$<BOOL:${SIESTA_WITH_FLOOK}>:SIESTA__FLOOK>
  $<$<BOOL:${SIESTA_WITH_DFTD3}>:SIESTA__DFTD3>
  $<$<BOOL:${SIESTA_WITH_WANNIER90}>:SIESTA__WANNIER90>
)

#get_target_property(out SCALAPACK::SCALAPACK INTERFACE_LINK_LIBRARIES)
#message(FATAL_ERROR "scalapc ${WITH_MPI} ${WITH_ELPA} ${out}")

# CMake linking order I do not understand
# The xmlf90 order seems important, but it shouldn't be since
# cmake should be able to determine correct dependency order.
# 1. xmlf90 before libpsml does not work
# 2. xmlf90 after libpsml works
# 3. removing xmlf90 works, since libpsml depends on xmlf90 (see top-level CMakeLists.txt)
# Huh..?
#
# A similar issue arises when the NetCDF installation is compiled with MPI capability. The
# order of the mpi_siesta (or MPI::MPI_Fortran in general) and the NetCDF targets is significant.
# For example, in CINECA with intel-oneapi-mpi and the GNU compiler, if NetCDF comes first the
# intel-specific 'include' directory is put first in the '-I' list by CMake, instead of the
# 'include/gfortran/<version-number>' directory. Putting the MPI dependency first seems to fix
# the issue.
#
target_link_libraries(SIESTA_libsiesta
  PUBLIC
  $<$<BOOL:${SIESTA_WITH_MPI}>:mpi_siesta>
  $<$<BOOL:${SIESTA_WITH_NCDF}>:${PROJECT_NAME}-libncdf>
  $<$<BOOL:${SIESTA_WITH_NETCDF}>:NetCDF::NetCDF_Fortran>
  # Internal projects
  ${PROJECT_NAME}-libsys
  ${PROJECT_NAME}-libncps
  ${PROJECT_NAME}-libpsop
  ${PROJECT_NAME}-libms
  ${PROJECT_NAME}-libunits
  libfdf::libfdf
  libpsml::libpsml
  libgridxc::libgridxc
  # Optional dependencies
  $<$<BOOL:${SIESTA_WITH_FLOOK}>:flook::flook>
  $<$<BOOL:${SIESTA_WITH_WANNIER90}>:wrapper-wannier90::wrapper-wannier90>
  $<$<OR:$<BOOL:${SIESTA_WITH_NCDF}>,$<BOOL:${SIESTA_WITH_FLOOK}>>:${PROJECT_NAME}-libfdict>
  $<$<BOOL:${SIESTA_WITH_DFTD3}>:s-dftd3::s-dftd3>
  $<$<BOOL:${SIESTA_WITH_ELPA}>:Elpa::elpa>
  $<$<BOOL:${SIESTA_WITH_PEXSI}>:${PROJECT_NAME}::pexsi>     #  $<$<BOOL:${SIESTA_WITH_PEXSI}>:MPI::MPI_CXX>
  $<$<BOOL:${SIESTA_WITH_CHESS}>:CheSS::CheSS>
  $<$<BOOL:${SIESTA_WITH_MPI}>:SCALAPACK::SCALAPACK>
  # Forced external dependencies

=== Tests/CMakeLists.txt ===
# This is the main engine for SIESTA tests.
# We should probably leave only the "simple" tests as the default
# without their output verification. This can be done by choosing
# the appropriate tests when making the cmake targets (maybe via labels?)

# TODO
# Instead of doing everything in CMake, first running, then checking.
# It would be better to control the 2nd run in a wrapper executable.
# This executable would run siesta, then check.
# That would also remove the problem of labels for tests.

file(MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/install_tests")
set(_TEST_PSEUDO_DIR "${CMAKE_CURRENT_SOURCE_DIR}/Pseudos")
set(_TEST_GLOB_DIR "${CMAKE_CURRENT_BINARY_DIR}")

# Perhaps this should be listed in the top-level CMakeLists.txt.
# We still rely on the old version (for now)
if(DEFINED VERIFY_TESTS)
  message(DEPRECATION "VERIFY_TESTS is superseeded by SIESTA_TESTS_VERIFY")
else()
  set(VERIFY_TESTS TRUE)
endif()

# Currently not a CACHE variable, it probably should be
set(SIESTA_TESTS_VERIFY "${VERIFY_TESTS}" PARENT_SCOPE)

file(
  COPY
    test-cfg.yml
    out_digest_yaml.awk
    yaml_compare.py
  DESTINATION
    "${CMAKE_CURRENT_BINARY_DIR}"
  )


list(APPEND CMAKE_MESSAGE_CONTEXT test)
message(STATUS "Default pseudo directory for tests: ${_TEST_PSEUDO_DIR}")

# Checking the output files requires Python3
# The below siesta_parseout function may break
# if Python 3 cannot be located!
find_package(Python3
  3.5.0 # subprocess limitation
  COMPONENTS Interpreter
  )


function(siesta_parseout)
  # Parse output files.
  set(oneValueArgs NAME OUTDIR OUTFILE PARENT ISSERIAL)
  set(multiValueArgs EXTRA_FILES LABELS)
  cmake_parse_arguments(_spout "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

  if(DEFINED _spout_UNPARSED_ARGUMENTS)
    if(NOT DEFINED _spout_NAME)
      # get name from the first argument
      list(POP_BACK _spout_UNPARSED_ARGUMENTS _spout_NAME)
    endif()
    list(LENGTH _spout_UNPARSED_ARGUMENTS _spout_len)
    if(_spout_len GREATER 0)
      message(FATAL_ERROR "Unparsed arguments in ${CMAKE_CURRENT_FUNCTION} test=${_spout_NAME}"
        "Arguments are:\n" "  ${_spout_UNPARSED_ARGUMENTS}")
    endif()
  endif()

  set(_spout_REFDIR "${CMAKE_CURRENT_SOURCE_DIR}/Reference")
  set(name "${_spout_PARENT}[verify]")

  # Note that the verification test produces an exit
  # code that is catched by cmake, so if the SIESTA_TESTS_VERIFY
  # env-var is not set, it will not run!
  add_test(
    NAME ${name}
    COMMAND ${Python3_EXECUTABLE} "${_TEST_GLOB_DIR}/yaml_compare.py"
          -c "${_TEST_GLOB_DIR}/test-cfg.yml"
          -p "${_TEST_GLOB_DIR}/out_digest_yaml.awk"
          -t "${_spout_OUTDIR}/${_spout_OUTFILE}.out"
          -r "${_spout_REFDIR}/${_spout_NAME}.out"
          -o "${_spout_OUTDIR}/${_spout_NAME}.yml"
  )

  set_tests_properties(${name}
    PROPERTIES
      ENVIRONMENT "SCRIPTS_DIR='${_TEST_GLOB_DIR}'"
      LABELS "${_spout_LABELS}"
      DEPENDS "${_spout_PARENT}"
      SKIP_RETURN_CODE 127)
  # Possible way to enforce dependency: FIXTURES_REQUIRED "${_spout_OUTFILE}-dep"

endfunction()


#  Function to set up tests
#
# It accepts a few arguments
# NAME : directory of test (optional, an unnamed argument will be accepted as NAME)
# PSEUDO_DIR : files to be copied in as pseudos
# EXEC: the target from which the executable would be retrieved
# MPI_NPROC : number of MPI processors
# OMP_NPROC : number of OpenMP processors
# EXTRA_FILES : extra files to be copied in to the run directory
# SERIAL : to skip MPI (regardless of other arguments)
# This function uses these external variables:
#  SIESTA_WITH_MPI
#  SIESTA_WITH_OPENMP
#  SIESTA_TESTS_MPI_NUMPROCS
### SUBTEST
function(siesta_subtest)
  set(options SERIAL)
  set(oneValueArgs NAME MPI_NPROC PSEUDO_DIR NAME_ALTER EXEC)
  set(multiValueArgs EXTRA_FILES LABELS)
  cmake_parse_arguments(_stest "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

  # Check for bad arguments
  # A single unparsed-argument will be the equivalent of NAME
  # in case it has not been passed.
  if(DEFINED _stest_UNPARSED_ARGUMENTS)
    if(NOT DEFINED _stest_NAME)
      # get name from the first argument
      list(POP_BACK _stest_UNPARSED_ARGUMENTS _stest_NAME)
    endif()
    list(LENGTH _stest_UNPARSED_ARGUMENTS _stest_len)
    if(_stest_len GREATER 0)
      message(FATAL_ERROR "Unparsed arguments in ${CMAKE_CURRENT_FUNCTION} test=${_stest_NAME}"
        "Arguments are:\n"
        "  ${_stest_UNPARSED_ARGUMENTS}")
    endif()
  endif()

  # Keyword only options
  # In this case serial may be used to overwrite MPI and OpenMP tests
  if(NOT DEFINED _stest_SERIAL)
    set(_stest_SERIAL FALSE)
  endif()

  # Name of test *must* be defined
  if(NOT DEFINED _stest_NAME)
    message(FATAL_ERROR "${CMAKE_CURRENT_FUNCTION} missing test directory argument: NAME")
  endif()

  set(msg_info "${_stest_NAME}")
  list(APPEND CMAKE_MESSAGE_INDENT "  ")

  # Check for number of ranks. It will be reduced to {SIESTA_TESTS_MPI_NUMPROCS} if too high.
  if(DEFINED _stest_MPI_NPROC)
    if(SIESTA_WITH_MPI)
      if(_stest_MPI_NPROC GREATER SIESTA_TESTS_MPI_NUMPROCS)
        message(WARNING "Reducing number of MPI processors in test ${_stest_NAME} to ${SIESTA_TESTS_NUMPROCS}<${_stest_MPI_NPROC}")
        set(_stest_MPI_NPROC ${SIESTA_TESTS_MPI_NUMPROCS})
      endif()
    endif()
    set(msg_info "${msg_info} (MPI=${_stest_MPI_NPROC})")
  else()
    # set default value
    set(_stest_MPI_NPROC ${SIESTA_TESTS_MPI_NUMPROCS})
  endif()

  # Check for OpenMP
  # It will understand this variable as the maximum value
  if(DEFINED ENV{OMP_NUM_THREADS})
    # set the OMP_NPROC to this value if undefined
    if(DEFINED _stest_OMP_NPROC)
      if(_stest_OMP_NPROC GREATER ENV{OMP_NUM_THREADS})
        message(WARNING "Reducing number of OpenMP ranks in test ${_stest_NAME} to $ENV{OMP_NUM_THREADS}<${_stest_OMP_NPROC}")
        set(_stest_OMP_NPROC $ENV{OMP_NUM_THREADS})
      endif()
    else()
      set(_stest_OMP_NPROC $ENV{OMP_NUM_THREADS})
    endif()
    set(msg_info "${msg_info} (OMP=${_stest_OMP_NPROC})")
  else()
    # set default value of 1
    set(_stest_OMP_NPROC 1)
  endif()

  message(VERBOSE "New test ${msg_info}")

  if(NOT DEFINED _stest_PSEUDO_DIR)
    set(_stest_PSEUDO_DIR "${_TEST_PSEUDO_DIR}")
  else()
    message(DEBUG "test(${_stest_NAME}) will be using pseudos from: ${_stest_PSEUDO_DIR}")
  endif()

  # Build up the variables
  # First set the test name
  if(NOT DEFINED _stest_NAME_ALTER)
    set(_stest_NAME_ALTER "${_stest_NAME}")
  endif()
  set(_stest_test "${_stest_NAME_ALTER}")
  # This just does not work, using set_tests_properties does not expose the
  # env variable. Whether this is due to the command being wrapped in `sh`
  # isn't fully clear to me. I basically have to force the env in the
  # execution statement. :(
  set(_stest_env "SIESTA_PS_PATH='${_stest_PSEUDO_DIR}'") # env-vars to add
  set(_stest_pre "")
  set(_stest_post "")
  if( SIESTA_WITH_MPI AND (NOT _stest_SERIAL) AND _stest_MPI_NPROC GREATER 1 )
    set(_stest_pre
      "${MPIEXEC_EXECUTABLE} ${MPIEXEC_NUMPROC_FLAG} ${_stest_MPI_NPROC} ${MPIEXEC_PREFLAGS}"
      )
    set(_stest_post
      "${MPIEXEC_POSTFLAGS}"
      )
    set(_stest_test "${_stest_test}_mpi${_stest_MPI_NPROC}")
  endif()

  if( SIESTA_WITH_OPENMP AND (NOT _stest_SERIAL) )
    list(APPEND _stest_env "OMP_NUM_THREADS=${_stest_OMP_NPROC}")
    set(_stest_test "${_stest_test}_omp${_stest_OMP_NPROC}")
  endif()

  # Create the working directory
  # Since we might have multiple tests for the same directory,
  # we will need to parse the options before doing anything
  set(_stest_tdir "${CMAKE_CURRENT_BINARY_DIR}/${_stest_test}")
  set(_stest_wdir "${CMAKE_CURRENT_BINARY_DIR}/${_stest_test}/work")
  get_filename_component(_stest_parent_dir "${CMAKE_CURRENT_BINARY_DIR}" NAME)

  # Now we can prepare the test directory:
  file(MAKE_DIRECTORY "${_stest_tdir}" "${_stest_wdir}")
  file(GLOB fdf_files "*.fdf")
  file(COPY
    ${fdf_files}
    DESTINATION "${CMAKE_CURRENT_BINARY_DIR}"
    )

  # Copy in extra files
  if(DEFINED _stest_EXTRA_FILES)
    message(DEBUG "test(${_stest_NAME}) copying extra files: ${_stest_EXTRA_FILES}")
    foreach(_extra IN LISTS _stest_EXTRA_FILES)
      file(COPY "${_extra}" DESTINATION "${_stest_wdir}")
    endforeach()
  endif()

  # Dirty fix for transiesta test.
  if(NOT DEFINED _stest_EXEC)
    set(_stest_EXEC "SIESTA_siesta_exe")
  endif()
  get_target_property(_stest_EXEC_name ${_stest_EXEC} OUTPUT_NAME)
  if( "${_stest_EXEC_name}" STREQUAL "" )
    set(_stest_EXEC_name "${_stest_EXEC}")
  endif()
  set(_stest_FULL_NAME "${_stest_EXEC_name}-${_stest_parent_dir}-${_stest_test}")

  add_test(
    NAME "${_stest_FULL_NAME}"
    COMMAND sh -c "SIESTA_PS_PATH='${_stest_PSEUDO_DIR}' ${_stest_pre} \
        '$<TARGET_FILE:${_stest_EXEC}>' -out ${_stest_test}.out \
        ../../${_stest_NAME}.fdf ${_stest_post}"
    WORKING_DIRECTORY "${_stest_wdir}"  )

  # Add environment variables to the test

  set_tests_properties("${_stest_FULL_NAME}"
    PROPERTIES
      ENVIRONMENT "${_stest_env}"
      LABELS "${_stest_LABELS}"
      SKIP_RETURN_CODE 127)
 
  # Possible way to enforce dependency: FIXTURES_SETUP "${_stest_test}-dep"
  list(POP_BACK CMAKE_MESSAGE_INDENT)

  # Add output verification
  siesta_parseout(${_stest_NAME_ALTER}
    ISSERIAL ${_stest_SERIAL}
    PARENT "${_stest_FULL_NAME}"
    OUTFILE "${_stest_test}"
    OUTDIR "${_stest_wdir}"
    LABELS "${_stest_LABELS}"
    )

endfunction()


add_subdirectory(00.BasisSets)
add_subdirectory(01.PseudoPotentials)
add_subdirectory(02.SpinPolarization)
add_subdirectory(03.SpinOrbit)
add_subdirectory(04.SCFMixing)
add_subdirectory(05.Bands)
add_subdirectory(06.DensityOfStates)
add_subdirectory(07.ForceConstants)
add_subdirectory(08.GeometryOptimization)
add_subdirectory(09.MolecularDynamics)
add_subdirectory(10.Functionals)
add_subdirectory(11.ElectronicProperties)
add_subdirectory(12.Solvers)
add_subdirectory(13.MiscOptions)
add_subdirectory(14.FileIO)
add_subdirectory(15.TDDFT)
add_subdirectory(16.TranSiesta)
add_subdirectory(17.Wannier90)
add_subdirectory(Dependency_Tests)
# Pop back the test context
list(POP_BACK CMAKE_MESSAGE_CONTEXT)

=== External/Lua-Engine/CMakeLists.txt ===
# Define the root folder of flook
set(FLOOK_ROOT "$ENV{FLOOK_ROOT}" CACHE FILEPATH "flook installation path")

# Try first a proper installation with a valid pkg-config file,
# augmenting any specified search paths with FLOOK_ROOT

if(NOT "${FLOOK_ROOT}" STREQUAL "" )
  list(APPEND CMAKE_PREFIX_PATH "${FLOOK_ROOT}")
endif()

find_package(PkgConfig REQUIRED QUIET)

macro(found_return message)
  list(POP_BACK CMAKE_MESSAGE_INDENT)
  set(FLOOK_FOUND TRUE)
  if("${message}" STREQUAL "")
    message(CHECK_PASS "found")
  else()
    message(CHECK_PASS "found ${message}")
  endif()
  return()
endmacro()


message(STATUS "Searching for flook library")
list(APPEND CMAKE_MESSAGE_INDENT "  ")

message(CHECK_START "trying pkg-config")
pkg_check_modules(FLOOK flook>=0.8.4)


macro(flook_add_dependencies)

  # TODO try if dl should be searched for by the libraries
  # this is very hard since we should do all combinations (likely)
  # dl is not a particularly good search name (user-names, etc are likely to
  # hit this key)
  message(CHECK_START "Searching for library [dl]")
  find_library(_flook_lib_dl dl
    DOC "Searching for dl library (dependency on flook)"
    REQUIRED
    )
  message(CHECK_PASS "Found library [dl]: ${_flook_lib_dl}")

  target_link_libraries(flook::flook INTERFACE ${_flook_lib_dl})

  message(CHECK_START "Searching for library [readline]")
  find_library(_flook_lib_readline readline
    DOC "Searching for readline library (dependency on flook)"
    REQUIRED
    )
  target_link_libraries(flook::flook INTERFACE ${_flook_lib_readline})
  message(CHECK_PASS "Found library [readline]: ${_flook_lib_readline}")

  # If the environment variable LUA_DIR is defined, flook will not compile
  # lua, and will not include it in libflookall. Therefore, we need to
  # explicitly include it.
  if(DEFINED ENV{LUA_DIR})
    message(CHECK_START "Searching for library [lua]")
    find_library(_flook_lib_lua lua
      DOC "Searching for lua library (dependency on flook)"
      REQUIRED
      PATHS ENV LUA_DIR
      PATH_SUFFIXES lib lib64
    )
    target_link_libraries(flook::flook INTERFACE ${_flook_lib_lua})
    message(CHECK_PASS "Found library [lua]: ${_flook_lib_lua}")
  endif()
endmacro()


if(FLOOK_FOUND)

  message(VERBOSE "FLOOK_LINK_LIBRARIES: ${FLOOK_LINK_LIBRARIES}")
  message(VERBOSE "FLOOK_INCLUDE_DIRS: ${FLOOK_INCLUDE_DIRS}")

  # Add libraries to namespace
  add_library(flook::flook INTERFACE IMPORTED GLOBAL)

  # add libraries
  target_link_libraries(flook::flook
    INTERFACE "${FLOOK_LINK_LIBRARIES}")
  target_include_directories(flook::flook
    INTERFACE "${FLOOK_INCLUDE_DIRS}")

  found_return("")
else()
  message(CHECK_FAIL "not found")
endif()

# Check for an installation without .pc file in FLOOK_ROOT and set libraries
# manually, assuming the recommended recipe has been followed...
# Search for the library in flook_root
message(CHECK_START "Checking libraries (flookall) in FLOOK_ROOT=${FLOOK_ROOT}")
find_library(FLOOK_LINK_LIBRARIES
  flookall
  HINTS ${FLOOK_ROOT}
  PATH_SUFFIXES lib lib64
  DOC "Libraries for flook"
  )

if("${FLOOK_LINK_LIBRARIES}" STREQUAL "FLOOK_LINK_LIBRARIES-NOTFOUND")
  message(CHECK_FAIL "not found")
  unset(FLOOK_LINK_LIBRARIES CACHE)
else()
  set(FLOOK_INCLUDE_DIRS "${FLOOK_ROOT}/include")
  message(VERBOSE "FLOOK_LINK_LIBRARIES: ${FLOOK_LINK_LIBRARIES}")
  message(VERBOSE "FLOOK_INCLUDE_DIRS: ${FLOOK_INCLUDE_DIRS}")

  add_library(flook::flook INTERFACE IMPORTED GLOBAL)
  # We know we have not added dl library
  target_link_libraries(flook::flook
    INTERFACE "${FLOOK_LINK_LIBRARIES}" "dl")
  target_include_directories(flook::flook
    INTERFACE "${FLOOK_INCLUDE_DIRS}")

  flook_add_dependencies()

  found_return("")
endif()


# Last resort will be to compile flook on the fly

include(ExternalProject)

# Compiling the internal Lua package requires tweaking if you are
# using a different platform than `linux`.
#
#    PLATFORM = aix | bsd | c89 | freebsd | generic
#               | linux | macosx | mingw | posix | solaris
#
# where the makefile system will try and guess the correct
# platform. However, if the build fails due to the Lua library, then
# please supply `PLATFORM` with the correct platform in your
# `setup.make` file.
#
# Please add more cases here if needed.

if("${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin")
  set(FLOOK_PLATFORM "macosx")
else()
  set(FLOOK_PLATFORM "linux")
endif()

configure_file(
  setup.make.in
  ${CMAKE_CURRENT_BINARY_DIR}/setup.make
  @ONLY
  )

# Find the make-command
find_program(MAKE_EXECUTABLE NAMES gmake make mingw32-make REQUIRED)


# Possible sources
set(url_default "https://github.com/ElectronicStructureLibrary/flook/archive/refs/tags/v0.8.4.tar.gz")
#
if(NOT "$ENV{FLOOK_PACKAGE}" STREQUAL "")

  set(url "$ENV{FLOOK_PACKAGE}")
  message(STATUS "flook: will compile on-the-fly from sources: $ENV{FLOOK_PACKAGE}")

elseif(EXISTS "${PROJECT_SOURCE_DIR}/External/Lua-Engine/flook/LICENSE")
  
  # The sub-module exists, or at least the LICENSE file does!

  set(url "${PROJECT_SOURCE_DIR}/External/Lua-Engine/flook")
  set(FLOOK_SOURCE_DIR "${url}" PARENT_SCOPE)
  message(STATUS "flook: will compile on-the-fly from submodule in External/Lua-Engine/flook")

else()

    set(url "${url_default}")

    message(WARNING
      "flook: Trying to download the sources directly from:"
      "  ${url_default} "
      "If this is not possible (no access to internet) then please define the "
      "environment variable FLOOK_PACKAGE pointing to a flook tarball with the sources. "
      "The easiest solution would be to check-out the submodule with the following commands:\n"
      "  cd <siesta-top-directory>\n"
      "  git submodule update --init External/Lua-Engine/flook"
      )
endif()

set(_flook_build_dir
  ${CMAKE_CURRENT_BINARY_DIR}/flook-prefix/src/flook-build)

set(FLOOK_INCLUDE_DIRS
  ${_flook_build_dir})
set(FLOOK_LINK_LIBRARIES
  ${_flook_build_dir}/libflookall.a)

ExternalProject_Add(flook
 URL "${url}"
 UPDATE_DISCONNECTED true
 ##CONFIGURE_HANDLED_BY_BUILD true
 DOWNLOAD_EXTRACT_TIMESTAMP TRUE
 CONFIGURE_COMMAND ""
 BUILD_COMMAND ${MAKE_EXECUTABLE} -j liball
 ## We avoid installing until we know how to specify the prefix...
 ##  ... the following should work but does not.
 ## INSTALL_COMMAND ${MAKE_EXECUTABLE} DESTDIR=<INSTALL_DIR> install
 INSTALL_COMMAND ""
 TEST_COMMAND ""
 #
 # See https://stackoverflow.com/questions/54866067/cmake-and-ninja-missing-and-no-known-rule-to-make-it
 #
 BUILD_BYPRODUCTS ${FLOOK_LINK_LIBRARIES}
)

#
# Copy configured setup.make file
# Copy also everything from SOURCE_DIR to BINARY_DIR (this is
# typically done by 'configure' for autotools, but it is not
# done for 'make' projects -- there must be a better way).
# Note special idiom for the 'cp' command. **Check** that it
# works with all shells?
#
ExternalProject_Add_Step(flook
  copy_setup_make
  COMMAND cp ${CMAKE_CURRENT_BINARY_DIR}/setup.make . && cp -a <SOURCE_DIR>/. .
  DEPENDEES download
  DEPENDERS build
  WORKING_DIRECTORY <BINARY_DIR>
)

add_library(flook::flook INTERFACE IMPORTED GLOBAL)

add_dependencies(flook::flook flook)

target_link_libraries(flook::flook
  INTERFACE
  ${FLOOK_LINK_LIBRARIES}
  )

target_include_directories(flook::flook
  INTERFACE
  ${FLOOK_INCLUDE_DIRS}
)

flook_add_dependencies()

=== Pseudo/vnl-operator/CMakeLists.txt ===
set(top_srcdir "${PROJECT_SOURCE_DIR}/Src")

add_library(psop_top_objs OBJECT
    "${top_srcdir}/m_getopts.f90"
    "${top_srcdir}/m_uuid.f90"
    "${top_srcdir}/periodic_table.f"
)

set(psop_sources
  check_grid.f90
  dpnint.f90
  m_kb.f90
  psop.f90
  psop_options.f90
)

if(NOT LIBGRIDXC_USES_PROCEDURE_POINTER)
  #
  # We might need to resolve the 'timer' reference in gridxc_wrappers
  #
  list(APPEND psop_sources  local_timer.f90)
endif()

add_executable(
  psop
  ${psop_sources}
)

# For semicore_info_froyen...
target_link_libraries(psop_top_objs
  PRIVATE
  ${PROJECT_NAME}-libncps
  ${PROJECT_NAME}-libsys
 )
 
target_link_libraries(
  psop
  PRIVATE
  psop_top_objs
  libgridxc::libgridxc
  libpsml::libpsml
  xmlf90::xmlf90
  ${PROJECT_NAME}-libncps
  ${PROJECT_NAME}-libpsop
  ${PROJECT_NAME}-libxc-trans
  ${PROJECT_NAME}-libsys
 )

if( SIESTA_INSTALL )
  install(
    TARGETS psop
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    )
endif()

=== Src/MPI/CMakeLists.txt ===

add_library(mpi_siesta
  # Sources
  mpi_siesta.F90
  mpi_interfaces.F90
  mpi__include.f90
  Interfaces.f90
  )

# We need to find "Interfaces.f90", which is generated in the build
#("binary") directory, so we need to add this directory to the list
# The following line will work also, but it is better practice to have
# target-specific settings
###set(CMAKE_INCLUDE_CURRENT_DIR ON)
target_include_directories(mpi_siesta PRIVATE "${CMAKE_CURRENT_BINARY_DIR}")

target_compile_definitions(
  mpi_siesta
  PUBLIC
  "$<$<BOOL:${SIESTA_WITH_GRID_SP}>:GRID_SP>"
  "$<$<BOOL:${SIESTA_WITH_NO_MPI_INTERFACES}>:NO_MPI_INTERFACES>"
)

  target_link_libraries(mpi_siesta PUBLIC MPI::MPI_Fortran)
  # So that clients of mpi_siesta can find its modules:
  target_include_directories(mpi_siesta INTERFACE ${CMAKE_CURRENT_BINARY_DIR})


# Handling of interface-generation script
# These generation scripts do not work with the suffix for the executables
siesta_suffix(
  NEW ""
  VARIABLES EXECUTABLE)

# Create the int and kind explorer targets
add_executable(mpi_int_explorer
  # Do not default to build this one, it is only
  # a temporary build dependency
  EXCLUDE_FROM_ALL
  int_explorer.f90
  )

add_executable(mpi_kind_explorer
  # Do not default to build this one, it is only
  # a temporary build dependency
  EXCLUDE_FROM_ALL
  kind_explorer.f90
  )

# Restore the old suffix before using this one.
siesta_suffix(
  POP
  VARIABLES EXECUTABLE)

# By setting the OUTPUT line, we ensure that this generation command
# is run before attempting to compile mpi_siesta
  
add_custom_command(
  # These are output files generated by the generate.sh script
  OUTPUT Interfaces.f90 VS.uses V_S.uses
  # Dependency targets
  DEPENDS mpi_int_explorer mpi_kind_explorer
  COMMAND sh "${CMAKE_CURRENT_SOURCE_DIR}/generate.sh"
  VERBATIM
  COMMENT "Creating MPI interfaces and modules"
  )

=== Src/easy-fdict/CMakeLists.txt ===
# This internal library uses a "pre-processed" file from the fdict
# distribution, containing the needed variable types.
  
add_library(
  ${PROJECT_NAME}-libfdict
   
  variable.F90
  dictionary.f90
  )

target_include_directories(
  ${PROJECT_NAME}-libfdict
  INTERFACE
  "${CMAKE_CURRENT_BINARY_DIR}"
)

=== Src/easy-ncdf/CMakeLists.txt ===
#
# Use a pre-generated source file (see top of file)
#
add_library(
  ${PROJECT_NAME}-libncdf
   
  netcdf_ncdf.F90
  )

if(WITH_NCDF_PARALLEL)
  target_compile_definitions(
  "${PROJECT_NAME}-libncdf"
  PRIVATE
  NCDF_PARALLEL
  )

# Note that libncdf uses the MPI module directly, through 'use mpi'
# This dependency has been put first to avoid problems with some
# MPI installations (e.g. when using oneapi-mpi with the GNU compiler in CINECA)

target_link_libraries(
   ${PROJECT_NAME}-libncdf
   PRIVATE
   MPI::MPI_Fortran
)
endif()

target_link_libraries(
   ${PROJECT_NAME}-libncdf
   # 'PUBLIC' to bring in fdict
   PRIVATE
   ${PROJECT_NAME}-libfdict
   NetCDF::NetCDF_Fortran
)

target_include_directories(
  ${PROJECT_NAME}-libncdf
  INTERFACE
  ${CMAKE_CURRENT_BINARY_DIR}
)

=== Src/libsys/CMakeLists.txt ===
#
#
add_library(
  ${PROJECT_NAME}-libsys
  sys.F90
  external_entries.F90
  )

target_include_directories(
  ${PROJECT_NAME}-libsys
  INTERFACE
  ${CMAKE_CURRENT_BINARY_DIR}
)

=== Src/libunits/CMakeLists.txt ===
add_library(
  ${PROJECT_NAME}-libunits
  STATIC
  units.F90
  units_legacy.f90
  units_codata2018.f90
  units_common.f90
  )

target_link_libraries(
  ${PROJECT_NAME}-libunits
  PUBLIC
  ${PROJECT_NAME}-libsys
)


# This is duplicated in ${PROJECT_SOURCE_DIR}/CMakeLists.txt
# The reason is that we might remove the legacy code in all codes
# and fully resort to only handling this in units* files in this library.
# That would be the longterm goal.

message(STATUS "Value of SIESTA_WITH_UNIT_CONVENTION in Src/libunits: ${SIESTA_WITH_UNIT_CONVENTION}")

# Lower case the units
string(TOLOWER "${SIESTA_WITH_UNIT_CONVENTION}" siesta_unit_convention)
if("${siesta_unit_convention}" STREQUAL "original" OR
   "${siesta_unit_convention}" STREQUAL "legacy")
  target_compile_definitions(${PROJECT_NAME}-libunits
    PUBLIC
    SIESTA__UNITS_ORIGINAL)
elseif("${siesta_unit_convention}" STREQUAL "codata2018")
  # pass - do nothing - the default
else()
  message(FATAL_ERROR "Unknown argument for SIESTA_WITH_UNIT_CONVENTION; not one of [original|legacy,codata2018]")
endif()
message(STATUS "Siesta using units: ${siesta_unit_convention}")

# Ensure module files are added to the inclusion
target_include_directories(
  ${PROJECT_NAME}-libunits
  INTERFACE "${CMAKE_CURRENT_BINARY_DIR}")

=== Src/libxc-compat/CMakeLists.txt ===
add_library(${PROJECT_NAME}-libxc-trans 
  m_libxc_compat.f90
  m_libxc_list.F90
  m_libxc_sxc_translation.F90
  m_siestaxc_list.F90
)

target_include_directories(
  ${PROJECT_NAME}-libxc-trans
  INTERFACE
  ${CMAKE_CURRENT_BINARY_DIR}
)

=== Src/wxml/CMakeLists.txt ===
add_library(
  ${PROJECT_NAME}-libwxml
   
  flib_wcml.f90
  flib_wstml.f90
  flib_wxml.f90
  m_wcml_coma.f90
  m_wxml_array_str.f90
  m_wxml_buffer.f90
  m_wxml_core.f90
  m_wxml_dictionary.f90
  m_wxml_elstack.f90
  m_wxml_error.f90
  m_wxml_escape.f90
  m_wxml_overloads.f90
  m_wxml_text.F90
  )

target_include_directories(
  ${PROJECT_NAME}-libwxml
  INTERFACE
  ${CMAKE_CURRENT_BINARY_DIR}
)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=siesta
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=5.0.0
pkgrel=1
pkgdesc="A first-principles materials simulation code using DFT. (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64')
url='https://siesta-project.org/siesta'
msys2_repository_url="https://gitlab.com/siesta-project/siesta"
msys2_references=(
  'aur: siesta'
)
license=('spdx:GPL-3.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-s-dftd3"
         "${MINGW_PACKAGE_PREFIX}-libfdf"
         "${MINGW_PACKAGE_PREFIX}-libgridxc"
         "${MINGW_PACKAGE_PREFIX}-libpsml"
         #"${MINGW_PACKAGE_PREFIX}-libxc"
         "${MINGW_PACKAGE_PREFIX}-mctc-lib"
         "${MINGW_PACKAGE_PREFIX}-netcdf-fortran"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openblas"
         "${MINGW_PACKAGE_PREFIX}-scalapack"
         "${MINGW_PACKAGE_PREFIX}-xmlf90")
makedepends=("${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-msmpi"
             "${MINGW_PACKAGE_PREFIX}-python")
_w90_ver=3.1.0
source=("https://gitlab.com/siesta-project/siesta/-/releases/${pkgver}/downloads/${_realname}-${pkgver}.tar.gz"
        "https://github.com/wannier-developers/wannier90/archive/v${_w90_ver}/wannier90-${_w90_ver}.tar.gz"
        "001-fix-build-on-mingw.patch")
sha256sums=('b7c18e0bbfb4c8707c483fc516953c10ea5489de43a744957a9b0e10fb4ae5af'
            '40651a9832eb93dec20a8360dd535262c261c34e13c41b6755fa6915c936b254'
            '7fa2cf211e958d658ebe832c4baec59bc664b859b135d95a46aa0125503c7228')
noextract=("wannier90-${_w90_ver}.tar.gz")

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}

  patch -Np1 -i "${srcdir}"/001-fix-build-on-mingw.patch
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  local _fflags=""
  if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
    _fflags+=" -fallow-invalid-boz"
  fi

  if [[ ${CARCH} == x86_64 ]]; then
    _fflags+=" -march=x86-64-v3"
    CFLAGS+=" -march=x86-64-v3"
  fi

  FFLAGS="${_fflags}" \
  WANNIER90_PACKAGE="${srcdir}"/wannier90-${_w90_ver}.tar.gz \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
      -DSIESTA_SHARED_LIBS=ON \
      -DSIESTA_WITH_FFTW=ON \
      -DSIESTA_WITH_LIBXC=ON \
      -DSIESTA_WITH_MPI=ON \
      -DSIESTA_WITH_NETCDF=ON \
      -DSIESTA_WITH_OPENMP=ON \
      -DSIESTA_WITH_WANNIER90=ON \
      -DSIESTA_WITH_FLOOK=OFF \
      -DSIESTA_TESTS=OFF \
      -DBLA_VENDOR=OpenBLAS \
      -DSCALAPACK_LIBRARY=${MINGW_PREFIX}/lib/libscalapack.dll.a \
      -DFortran_FLAGS_RELEASE="-O3" \
      -DC_FLAGS_RELEASE="-O3" \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"
}
